//global variables
var gPrefBranch = null;
var gElementIDs = ["txtIncrement",
    "chkUpdown",
    "chkBack",
    "chkHide", 
    "rgpBtndir",
    "txtDelay", 
    "rgpSlidedir"]; 

/*********************************************************************************
 *  function:     optionsLoad
 *	description:  window load function
 ********************************************************************************/  		
function optionsLoad()
{
  var prefService = "@mozilla.org/preferences-service;1";
  prefService = Components.classes[prefService].getService(Components.interfaces.nsIPrefService); 
  gPrefBranch = prefService.getBranch(null);  
                
  for (var i=0; i<gElementIDs.length; ++i) {
    var elt = document.getElementById(gElementIDs[i]);
    var prefstring = elt.getAttribute("prefstring");
    var preftype = elt.getAttribute("preftype");
    var prefattribute = elt.getAttribute("prefattribute");
    var prefvalue = getPref(prefstring, preftype);
    switch (elt.tagName) {
      case "checkbox":
        elt.checked = prefvalue;
        break;
      case "radiogroup":
        for (var j=0; j<elt.childNodes.length; ++j) {
          if (elt.childNodes[j].value == prefvalue) {
            elt.selectedItem = elt.childNodes[j];
            break;
          }
        }
        break; 
      case "textbox":
      default:
        elt.value = prefvalue;
        break;
    }
  }
}

/*********************************************************************************
 *  function:     optionsAccept
 *	description:  called on dialogaccept event
 ********************************************************************************/  
function optionsAccept()
{
  var str = document.getElementById("optionsBundle");
  
  for (var i=0; i<gElementIDs.length; ++i) {
    var elt = document.getElementById(gElementIDs[i]);
    var prefstring = elt.getAttribute("prefstring");
    var preftype = elt.getAttribute("preftype");
    var prefattribute = elt.getAttribute("prefattribute");
    var prefvalue;
    switch (elt.tagName) {
      case "checkbox":
        prefvalue = elt.checked;
        break;
      case "radiogroup":
        prefvalue = elt.selectedItem.value;
        break; 
      case "textbox":
      default:
        prefvalue = elt.value;
        break;
    }
    if (preftype == "int" && isNaN(parseInt(prefvalue))) {
      var name = str.getString(prefstring);
      var message = str.getFormattedString("error.numeric", [name]);
      var title = str.getString("error.title");

      var promptSvc = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      promptSvc.alert(window, title, message);
      return false
    }
    else
      setPref(prefstring, preftype, prefvalue);
  }
  
  return true;
}

/*********************************************************************************
 *  function:     getPref
 *	description:  function used to return pref value
 ********************************************************************************/
function getPref(aString,aType)
{
  var val;
  switch(aType) {
    case "bool":
      val = gPrefBranch.getBoolPref(aString);
      break;
    case "int":
      val = gPrefBranch.getIntPref(aString);
      break;
    case "color":
    case "string":
    default:
      val = gPrefBranch.getCharPref(aString);
      break;  
  }
  return val;
}  

/*********************************************************************************
 *  function:     setPref
 *	description:  function used to set pref value
 ********************************************************************************/
function setPref(aString, aType, aValue)
{
  switch(aType) {
    case "bool":
      gPrefBranch.setBoolPref(aString, aValue);
      break;
    case "int":
      gPrefBranch.setIntPref(aString, aValue);
      break;
    case "color":
    case "string":
    default:
      gPrefBranch.setCharPref(aString, aValue);
      break;    
  }
}

